"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useFetchMarketCode = exports.useUpbitWebSocket = void 0;
var react_1 = require("react");
var lodash_1 = require("lodash");
var socketDataEncoder = function (socketData) {
    try {
        var encoder = new TextDecoder("utf-8");
        var rawData = new Uint8Array(socketData);
        var data = JSON.parse(encoder.decode(rawData));
        return data;
    }
    catch (error) {
        console.error(error);
    }
};
var typeChecker = function (type) {
    try {
        var isValid = true;
        if (type != "ticker" && type != "orderbook" && type != "trade") {
            isValid = false;
        }
        return isValid;
    }
    catch (error) {
        console.error(error);
    }
};
var getLastBuffers = function (buffer, maxNumResult) {
    try {
        var result = [];
        for (var i = buffer.length - 1; i >= 0; i--) {
            var isExist = false;
            for (var j = 0; j < result.length; j++) {
                if (result[j].code === buffer[i].code) {
                    isExist = true;
                }
                else
                    continue;
            }
            if (!isExist)
                result.push(buffer[i]);
            else {
                if (maxNumResult <= result.length)
                    break;
                else
                    continue;
            }
        }
        return result;
    }
    catch (error) {
        console.error(error);
    }
};
var sortBuffers = function (originalBuffers, sortOrder) {
    try {
        var result = [];
        for (var i = 0; i < sortOrder.length; i++) {
            var targetCode = sortOrder[i].market;
            for (var j = 0; j < originalBuffers.length; j++) {
                if (targetCode === originalBuffers[j].code) {
                    result.push(originalBuffers[j]);
                    break;
                }
                else
                    continue;
            }
        }
        return result;
    }
    catch (error) {
        console.error(error);
    }
};
var updateSocketData = function (origininalData, newData) {
    try {
        var copyOriginal = (0, lodash_1.cloneDeep)(origininalData);
        var copyNew = (0, lodash_1.cloneDeep)(newData);
        if (copyOriginal && newData) {
            for (var i = 0; i < copyOriginal.length; i++) {
                var target = copyOriginal[i];
                for (var j = 0; j < newData.length; j++) {
                    if (target.code === newData[j].code) {
                        copyOriginal[i] = newData[j];
                        copyNew[j] = null;
                        break;
                    }
                    else
                        continue;
                }
            }
            // 원본 데이터에 없는 market 데이터가 새롭게 받은 데이터에 존재하는 case
            var remainNew = copyNew.filter(function (element) { return element !== null; });
            if (remainNew.length > 0) {
                copyOriginal.push.apply(copyOriginal, remainNew);
            }
        }
        return copyOriginal;
    }
    catch (error) {
        console.error(error);
    }
};
var updateQueueBuffer = function (buffer, maxSize) {
    try {
        var copyBuffer = (0, lodash_1.cloneDeep)(buffer);
        while (copyBuffer.length >= maxSize) {
            copyBuffer.shift();
        }
        return copyBuffer;
    }
    catch (error) {
        console.error(error);
    }
};
function useUpbitWebSocket(targetMarketCodes, type, options) {
    if (targetMarketCodes === void 0) { targetMarketCodes = [
        {
            market: "KRW-BTC",
            korean_name: "비트코인",
            english_name: "Bitcoin",
        },
    ]; }
    if (type === void 0) { type = "ticker"; }
    if (options === void 0) { options = { throttle_time: 400, max_length_queue: 100 }; }
    var SOCKET_URL = "wss://api.upbit.com/websocket/v1";
    var throttle_time = options.throttle_time, max_length_queue = options.max_length_queue;
    var socket = (0, react_1.useRef)(null);
    var buffer = (0, react_1.useRef)([]);
    var _a = (0, react_1.useState)(false), isConnected = _a[0], setIsConnected = _a[1];
    var _b = (0, react_1.useState)([]), loadingBuffer = _b[0], setLoadingBuffer = _b[1];
    var _c = (0, react_1.useState)(), socketData = _c[0], setSocketData = _c[1];
    var throttled = (0, react_1.useCallback)((0, lodash_1.throttle)(function () {
        try {
            var lastBuffers = getLastBuffers(buffer.current, targetMarketCodes.length);
            switch (type) {
                case "ticker":
                    var sortedBuffers = sortBuffers(lastBuffers, targetMarketCodes);
                    setLoadingBuffer(sortedBuffers);
                    buffer.current = [];
                    break;
                case "orderbook":
                    if (lastBuffers)
                        setSocketData(lastBuffers[0]);
                    buffer.current = [];
                    break;
                case "trade":
                    var updatedBuffer = updateQueueBuffer(buffer.current, max_length_queue);
                    buffer.current = updatedBuffer;
                    setSocketData(updatedBuffer);
                    break;
                default:
                    break;
            }
        }
        catch (error) {
            throw new Error();
        }
    }, throttle_time), [targetMarketCodes]);
    // socket 세팅
    (0, react_1.useEffect)(function () {
        try {
            var isTypeValid = typeChecker(type);
            if (!isTypeValid) {
                console.error("[Error] | input type is unknown. (input type should be 'ticker' or 'orderbook' or 'trade')");
                throw new Error();
            }
            if (type === "orderbook" || type === "trade") {
                if (targetMarketCodes.length > 1) {
                    console.error("[Error] | 'Length' of Target Market Codes should be only 'one' in 'orderbook' and 'trade'. you can request only 1 marketcode's data, when you want to get 'orderbook' or 'trade' data.");
                    throw new Error();
                }
            }
            if (targetMarketCodes.length > 0 && !socket.current) {
                socket.current = new WebSocket(SOCKET_URL);
                socket.current.binaryType = "arraybuffer";
                var socketOpenHandler = function () {
                    var _a;
                    setIsConnected(true);
                    console.log("[연결완료] | socket Open Type: ", type);
                    if (((_a = socket.current) === null || _a === void 0 ? void 0 : _a.readyState) == 1) {
                        var sendContent = [
                            { ticket: "test" },
                            {
                                type: type,
                                codes: targetMarketCodes.map(function (code) { return code.market; }),
                            },
                        ];
                        socket.current.send(JSON.stringify(sendContent));
                        console.log("message sending done");
                    }
                };
                var socketCloseHandler = function () {
                    setIsConnected(false);
                    setLoadingBuffer([]);
                    setSocketData(null);
                    buffer.current = [];
                    console.log("연결종료");
                };
                var socketErrorHandler = function (error) {
                    console.error("[Error]", error);
                };
                var socketMessageHandler = function (evt) {
                    var data = socketDataEncoder(evt.data);
                    buffer.current.push(data);
                    throttled();
                };
                socket.current.onopen = socketOpenHandler;
                socket.current.onclose = socketCloseHandler;
                socket.current.onerror = socketErrorHandler;
                socket.current.onmessage = socketMessageHandler;
            }
            return function () {
                if (socket.current) {
                    if (socket.current.readyState != 0) {
                        socket.current.close();
                        socket.current = null;
                    }
                }
            };
        }
        catch (error) {
            throw new Error();
        }
    }, [targetMarketCodes]);
    (0, react_1.useEffect)(function () {
        try {
            if (loadingBuffer.length > 0) {
                if (!socketData) {
                    setSocketData(loadingBuffer);
                }
                else {
                    setSocketData(function (prev) {
                        return updateSocketData(prev, loadingBuffer);
                    });
                    setLoadingBuffer([]);
                }
            }
        }
        catch (error) {
            console.log(error);
        }
    }, [loadingBuffer]);
    return { socket: socket.current, isConnected: isConnected, socketData: socketData };
}
exports.useUpbitWebSocket = useUpbitWebSocket;
function useFetchMarketCode() {
    var _this = this;
    var REST_API_URL = "https://api.upbit.com/v1/market/all?isDetails=false";
    var options = { method: "GET", headers: { Accept: "application/json" } };
    var _a = (0, react_1.useState)(true), isLoading = _a[0], setIsLoading = _a[1];
    var _b = (0, react_1.useState)([]), marketCodes = _b[0], setMarketCodes = _b[1];
    var fetchMarketCodes = (0, react_1.useCallback)(function () { return __awaiter(_this, void 0, void 0, function () {
        var response, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetch(REST_API_URL, options)];
                case 1:
                    response = _a.sent();
                    return [4 /*yield*/, response.json()];
                case 2:
                    result = _a.sent();
                    setMarketCodes(result);
                    setIsLoading(false);
                    return [2 /*return*/];
            }
        });
    }); }, []);
    (0, react_1.useEffect)(function () {
        fetchMarketCodes();
    }, []);
    return { isLoading: isLoading, marketCodes: marketCodes };
}
exports.useFetchMarketCode = useFetchMarketCode;
